	PROGRAM QTABPLT
C
	PARAMETER (NPTS=37)
	DIMENSION X(NPTS),Y(NPTS,6)
	DIMENSION WINDANG(6)
	DATA WINDANG/0.,45.,90.,135.,180.,270./
	CHARACTER*60 FILE,LINE
C
	DATA FILE/'/auto/cers0/long/geomodel/QS_MODL0001'/
C
C	BYTE TAB
c	DATA TAB/9/
C
C  READ TABULAR GEOPHYSICAL MODEL FUNCTION FILE
C
	PRINT 1,FILE
1	FORMAT(' QS Geophysical Model Function Plot Program'//
     $		' Default Model Function File:',A,/' Enter New File: ',$)
	READ(*,90) LINE
90	FORMAT(A60)
	IF (LINE.NE.' ') FILE=LINE
C
	CALL MFTABLEQ (FILE)
C
	PRINT 2
  2	FORMAT(' Enter Incidence Angle: ',$)
	READ(*,*) AINC
	IBPOL=1
	if (ainc.gt.50.0) IBPOL=2
c	PRINT 3
c  3	FORMAT(' Enter Polarization: (1=H,2=V) ',$)
c	READ(*,*) IBPOL
	BANG=0.0
C	WRITE (1,*) AINC,IBPOL,FILE
C
	ANGCON=360./FLOAT(NPTS-1)
	DO 1000 IDIR=1,NPTS
		X(IDIR)=(IDIR-1)*50.0/FLOAT(NPTS-1)+0.5
		WIND=X(IDIR)
		DO 900 ISPD=1,6
			WDIR=WINDANG(ISPD)
			CALL MODEL_FUNCTIONQ (BANG,AINC,IBPOL,WIND,WDIR,SIG)
			if (sig.le.0.0) sig=1.e-36
			SIGMA0=10.0*ALOG10(SIG)
			Y(IDIR,ISPD)=SIGMA0
 900		CONTINUE
c		WRITE(1,950) WIND,(TAB,Y(IDIR,ISPD),ISPD=1,5)
950		FORMAT(1X,F6.2,5(A1,F6.2))
1000	CONTINUE
C
	CALL GLPLOT(X,Y,5,NPTS,5,NPTS,-14,0,-6.,-5.,
     $		6.01,-0.15,1002.,'Speed (m/s)',11,
     $		8.01,0.15,1003.,'Sigma-0 (dB)  ',12,
     $		'Azimuths: 0, 45, 90, 135, 180          ',35,0.,50.,-35.0,0.0)
	CALL CTERM(-1)
	CALL SYMBOL(0.,5.55,0.13,FILE,0.,60,-1)
	CALL SYMBOL(0.,5.35,0.13,'Polarization: ',0.,13,-1)
	IF (IBPOL.EQ.1) THEN
		CALL SYMBOL(999.,999.,0.13,'H  ',0.,3,-1)
	ELSE
		CALL SYMBOL(999.,999.,0.13,'V  ',0.,3,-1)
	ENDIF
	CALL SYMBOL(999.,999.,0.13,'Incidence Angle: ',0.,17,-1)
	CALL NUMBER(999.,999.,0.13,AINC,0.,4.01,-1)
	CALL SYMBOL(999.,999.,0.13,' deg',0.,4,-1)
	CALL PLOT(0.,0.,5)
	CALL CTERM(2)
	CALL RTERM(2)
	CALL NEWPAGE
C

	ANGCON=360./FLOAT(NPTS-1)
	DO 21000 IDIR=1,NPTS
		X(IDIR)=(IDIR-1)*ANGCON
		WDIR=X(IDIR)
		DO 2900 ISPD=1,6
		        WIND=(ISPD-1)*5+3
			CALL MODEL_FUNCTIONQ (BANG,AINC,IBPOL,WIND,WDIR,SIG)
			if (sig.le.0.0) sig=1.e-36
			SIGMA0=10.0*ALOG10(SIG)
			Y(IDIR,ISPD)=SIGMA0
 2900		CONTINUE
21000	CONTINUE
C
	CALL GLPLOT(X,Y,5,NPTS,5,NPTS,-14,0,-6.,-5.,
     $		7.01,-0.15,1003.,'Direction (deg)',15,
     $		8.01,0.15,1003.,'Sigma-0 (dB)  ',12,
     $		'Speeds: 3, 8, 12, 17, 22 m/s          ',35,0.,360.,-35.0,0.0)
	CALL CTERM(-1)
	CALL SYMBOL(0.,5.55,0.13,FILE,0.,60,-1)
	CALL SYMBOL(0.,5.35,0.13,'Polarization: ',0.,13,-1)
	IF (IBPOL.EQ.1) THEN
		CALL SYMBOL(999.,999.,0.13,'H  ',0.,3,-1)
	ELSE
		CALL SYMBOL(999.,999.,0.13,'V  ',0.,3,-1)
	ENDIF
	CALL SYMBOL(999.,999.,0.13,'Incidence Angle: ',0.,17,-1)
	CALL NUMBER(999.,999.,0.13,AINC,0.,4.01,-1)
	CALL SYMBOL(999.,999.,0.13,' deg',0.,4,-1)
	CALL PLOT(0.,0.,5)
	CALL CTERM(2)
	CALL RTERM(2)

	CALL PLOTND
C
	STOP
	END
c
c
     	SUBROUTINE MFTABLEQ (nfile)
c
c	NSCAT Algorithm Module 4.2.3
c	---------------------------------------------------------------
c	Author:  R. Scott Dunbar		Created:  24 Feb 1987
c						Revised:   1 Apr 1987
c       Modified for QS model function: DGL  2 Oct 1999
c	---------------------------------------------------------------
c	Purpose:
c
c	Read model function table file into memory for use in wind 
c	  retrieval.
c
c	---------------------------------------------------------------
	character*(*) nfile
      	common /mfunc/ table(40:60,0:50,0:90)
c	---------------------------------------------------------------
c	Open model function table file:
c     	open(unit=16,name=nfile,status='old',form='unformatted') !,readonly)
c     	read (16) table
c	close (unit=16)
c
	OPEN (UNIT = 16, FILE=nfile, STATUS='old',ACCESS='direct',
     $       RECL = 389844)
	READ (16, REC=1) table
C	READ (16, REC=2) model_kpm_table
	CLOSE (UNIT = 16)
	call swapbuffer(table,389844/4)
c
      	return
      	end
c
c
	subroutine swapbuffer(ib,n)
	real ib(1)
	do i=1,n
	   call swap4(ib(i))
	end do
	return
	end
c
	subroutine swap4(ib)
	byte ib(4),t1,t2
	t1=ib(1)
	t2=ib(2)
	ib(1)=ib(4)
	ib(2)=ib(3)
	ib(3)=t2
	ib(4)=t1
	return
	end
c
	SUBROUTINE MODEL_FUNCTIONQ (azi,tht,kpol,u,phi,nrcs)
c
c	Version for use in Wind Field Simulation -- 19 August 1987
c	Author:  R. Scott Dunbar
c       Modified for QS model function: DGL  2 Oct 1999
c	---------------------------------------------------------------
c	Purpose:
c
c	Look up and interpolate the value of the sigma-0 model function
c	  for the given values of wind direction and wind speed.
c
c	Uses multilinear interpolation among the nearest 8 model function 
c	  values in the model function table.
c
c	INPUTS:
c		azi  =  cell azimuth w.r.t. north (deg)
c		tht  =  incidence angle (deg)
c		kpol =  antenna polarization [V = 1, H = 2] (*not used for QS)
c		u    =  wind speed (m/s)
c		phi  =  wind direction (deg)
c	OUTPUT:
c		nrcs =  model sigma-0 from table
c	---------------------------------------------------------------
c	Data declarations:
c
	real nrcs		! returned value of model function
	real mfun(2,2)		! intermediate table of interpolated values
      	common /mfunc/ table(40:60,0:50,0:90)  ! model function table
     	data kt1min, kt1max /40, 59/
c	--------------------------------------------------------------
c 	Adjust the relative azimuth into the range (0.,180.) degrees
c 	  and get interpolation coefficient q:
c
	chi 	   = azi - phi
        chi        = amod(chi,360.)
	if (chi .lt. 0.)   chi = chi  + 360.
      	if (chi .gt. 180.) chi = 360. - chi
     	ichi       = int(chi/2.)
	q          = chi/2. - ichi
	q1         = 1. - q
c	---------------------------------------------------------------
c	Get interpolation coefficients w.r.t. incidence angle:
c
        htht       = tht  ! /2.		! cut tht in half
	kt1        = int(htht)		! first index
     	if (kt1 .le. kt1min) kt1 = kt1min
      	if (kt1 .ge. kt1max) kt1 = kt1max
      	kt2        = kt1 + 1		! second index
     	at2        = htht - kt1		! second coefficient
      	at1        = 1. - at2		! first coefficient
c	---------------------------------------------------------------
c	Get interpolation coefficient w.r.t. u:
c
	ju         = int(u)		! primary speed index
	p          = u - ju
	p1         = 1. - p
c	---------------------------------------------------------------
c	Interpolate with respect to incidence angle:
c
	do 40 i = 1,2
	    kchi = i + ichi - 1
	    if (kchi .gt. 90) kchi = 180 - kchi
	    do 50 j = 1,2
		ku = j + ju - 1
		if (ku .eq. 0) then
			mfun(j,i) = 0.0
		else
			mfun(j,i) =  at1*table(kt1,ku,kchi) +
     $			     at2*table(kt2,ku,kchi) !,kpol)
		endif
 50	    continue
 40	continue
c	---------------------------------------------------------------
c	Do bilinear interpolation of the working table to find nrcs(i):
c
	nrcs = p1*q1*mfun(1,1) + p*q1*mfun(2,1) + 
     *		   q*p1*mfun(1,2) +  p*q*mfun(2,2)
c
c	---------------------------------------------------------------
	return
	end




