function load_QMOD4
%
% load JPL version 4 QuikSCAT geophysical model function into global
% variable GMF
%
% GMF(i,j,k)=sigma-0 (normal space) where
%   i=incidence angle* in deg - 40 (40..60)
%   j=wind speed in m/s * 10 (0..50 m/s)
%   k=relative wind direction in deg (chi) (0..360)
%   * Note: QuikSCAT polarization is included in incidence angle

% written 5 Jul 2005 by D.Long at BYU

fname='QS_MODLa004';
fid=fopen(fname,'r','ieee-le');
GMF1=fread(fid,21*501*361,'float32');
global GMF
GMF=reshape(GMF1,[21 501 361]);
fclose(fid);
